;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Tank Ardad. A tank videogame.
;;  Copyright (C) 2018 Adrian Bardisa Serrano, Ariel Palma Arriaga, David Ruiz Falco
;;  abs90@alu.ua.es drf7@alu.ua.es acpa2@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.include "cpctelera.h.s"
.include "entity.h.s"
.include "main.h.s"
.include "colisions.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FUNCIÓN PARA COMPROBAR SI HAY BLOQUE EN EL EJE X
;; ENTRY:
;;          hl -> puntero al byte que queremos mirar su color
;;          
;; DESTROY: AF, BC, DE, HL
;;          
;; RETURN:
;;                 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_get_next_pixel_left:

    bit #6,(hl)
    jr nz , pixel_color_left
    bit #2,(hl)
    jr nz , pixel_color_left
    bit #4,(hl)
    jr nz , pixel_color_left
    bit #0,(hl)
    jr nz , pixel_color_left
    ld a,#0x00
    ret
pixel_color_left:
    ld a,#0x01
ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FUNCIÓN PARA COMPROBAR SI HAY BLOQUE EN EL EJE X
;; ENTRY:
;;          hl -> puntero al byte que queremos mirar su color
;;          
;; DESTROY: AF, BC, DE, HL
;;          
;; RETURN:
;;                 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_get_next_pixel_right:

    bit #7,(hl)
    jr nz , pixel_color_right
    bit #3,(hl)
    jr nz , pixel_color_right
    bit #5,(hl)
    jr nz , pixel_color_right
    bit #1,(hl)
    jr nz , pixel_color_right
    ld a,#0x00
    ret
pixel_color_right:
    ld a,#0x01
ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FUNCIÓN PARA COMPROBAR SI HAY BLOQUE EN EL EJE X
;; ENTRY:
;;             ld de ->> punteroa dirección de memoria C000
;;             ld b  ->> posicion y del heroe
;;             ld c  ->> posicion x del heroe
;;          
;; DESTROY:
;;          

;; RETURN:
;;                 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;




ent_colision_x:
    call ent_get_next_pixel_left
    add a
    jr nz,collision_color_x
    ld de,#0x0003
    add hl,de
    call ent_get_next_pixel_right
    add a
    jr nz,collision_color_x  
    ld a,#0x00
    ret
collision_color_x:
    ld a,#0x01
    ret





ent_get_next_pixel_up:
    push hl
    ld a,#0
    ld d,a
    ld a,(hl)
    add a
    jr nz,colision_up
    inc d
    ld b,#0x00
    ld c,#0x01
    add hl,bc
    ld a,(hl)
    add a
    jr nz,colision_up
    add hl,bc
    inc d
    ld a,(hl)
    add a
    jr nz,colision_up
    inc d
    add hl,bc
    ld a,(hl)
    add a
    jr nz,colision_up
    pop hl
    ld a,#0x00
    ret
colision_up:
    pop hl
    ld a,#0x01
    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FUNCIÓN PARA COMPROBAR SI HAY BLOQUE EN EL EJE X
;; ENTRY:
;;             ld de ->> punteroa dirección de memoria C000
;;             ld b  ->> posicion y del heroe
;;             ld c  ->> posicion x del heroe
;;          
;; DESTROY:
;;          

;; RETURN:
;;                 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_colision_y:
    add c
    ld b,de_y(ix)
    ld c,de_x(ix)
    add b
    ld b,a
    call cpct_getScreenPtr_asm
    call ent_get_next_pixel_up
ret




