;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Tank Ardad. A tank videogame.
;;  Copyright (C) 2018 Adrian Bardisa Serrano, Ariel Palma Arriaga, David Ruiz Falco
;;  abs90@alu.ua.es drf7@alu.ua.es acpa2@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.globl ent_draw
.globl ent_clear
.globl ent_update
.globl hero_data
.globl enemy_data
.globl hero_getPointerHL
.globl ent_move_hero
.globl ent_new
.globl ent_copy
.globl ent_doForAll
.globl ent_borrar
.globl ent_shot
.globl hero_shot
.globl enemy_shot
.globl enemy_shot_constant
.globl ent_update_draw_shoot
.globl ent_enemy_shot
.globl entity_vector
.globl entity_vector_shots
.globl _sprite_Hero_up
.globl _sprite_Hero_up2
.globl _sprite_Hero_down
.globl _sprite_Hero_down2
.globl _sprite_Hero_right
.globl _sprite_Hero_right2
.globl _sprite_Hero_left
.globl _sprite_Hero_left2

.globl _sprite_Enemy_left
.globl _sprite_Enemy_left2
.globl _sprite_Enemy2_left
.globl _sprite_Enemy2_left2
.globl _sprite_Enemy3_left
.globl _sprite_Enemy3_left2

.globl _sprite_Enemy_down
.globl _sprite_Enemy_down2
.globl _sprite_Enemy2_down
.globl _sprite_Enemy2_down2
.globl _sprite_Enemy3_down
.globl _sprite_Enemy3_down2

.globl _sprite_Enemy_right
.globl _sprite_Enemy_right2
.globl _sprite_Enemy2_right
.globl _sprite_Enemy2_right2
.globl _sprite_Enemy3_right
.globl _sprite_Enemy3_right2

.globl _sprite_Enemy_up
.globl _sprite_Enemy_up2
.globl _sprite_Enemy2_up
.globl _sprite_Enemy2_up2
.globl _sprite_Enemy3_up
.globl _sprite_Enemy3_up2

.globl _sprite_Enemy22_down
.globl _sprite_Enemy22_up
.globl _sprite_Enemy22_left
.globl _sprite_Enemy22_right

.globl _sprite_Bullet_up
.globl _sprite_Bullet_down
.globl _sprite_Bullet_right
.globl _sprite_Bullet_left
.globl cpct_getRandom_mxor_u8_asm
.globl ent_move_generic
.globl m_num_ent
.globl k_entity_size
.globl m_next_entity
.globl hero_data_default
.globl comprobar_colision
.globl _sprite_hearthEmpty
.globl cambiar_sprite
.globl cambiar_spriteB
.globl hero_shot_default
.globl create_enemy
.globl init_enemy
.globl initialize_enemies_map1
.globl initialize_enemies_map2
.globl initialize_enemies_map3
.globl initialize_enemies_map4
.globl respawn_enemies
.globl ex_sprite_spriteB
.globl _sprite_exp1
.globl _sprite_exp2
.globl _sprite_exp3
.globl _sprite_exp4
.globl load_explosion
.globl explosion
.globl load_strong_enemies
.globl load_weak_enemies
.globl reset_explosion
.globl explosion
.globl load_noob_enemies
.globl load_final_enemies
;;;;;
;;;;; MACROS
;;;;;

.include "render.h.s"


.macro DefineEntity _name, _x, _y, _vx, _vy, _upd, _eye, _sprite, _hp, _tmp, _xa, _ya, _xaa, _yaa, _spriteB

_name: 
   DefineDrawableEntity _name'_dw, _x, _y, _sprite
   .db   _vx, _vy    ;; VX, VY
   .dw   _upd        ;; Update 2 bytes
   .db   _eye        ;; Direction where the entetity is looking /En la entidad shot si _eye=0 la bala se esta disparando
   .db   _hp         ;; Vidas del tanque / En la entidad shot indica hacia donde mira la bala
   .db   _tmp
   .db   _xa
   .db   _ya
   .db   _xaa
   .db   _yaa
   .dw   _spriteB
_name'_size = . - _name
.endm

.macro DefineEntityDefault _name, _suf
   DefineEntity _name'_suf, 0, 0, 0, 0, 0xFFFF, 0, 0xFFFF, 0, 0, 0, 0, 0, 0, 0xFFFF

.endm

.macro DefineNEntities _name, _n
   _c = 0
   .rept _n
      DefineEntityDefault _name, \_c
      _c = _c + 1
   .endm
.endm

;;;;;;;;;;;
;;Variables
;;;;;;;;;;;

e_de = 0
e_de_size = 4 ;tamaño de la entidad dibujable
e_vx = 0 + e_de_size
e_vy = 1 + e_de_size
e_up_l = 2 + e_de_size
e_up_h = 3 + e_de_size
;Para donde esta apuntando, 3 si apunta hacia arriba, 
;2 hacia la derecha, 1 hacia abajo, 4 izquierdaa
e_eye = 4 + e_de_size
e_hp = 5 + e_de_size

e_tmp = 6 + e_de_size
e_xa = 7 + e_de_size
e_ya = 8 + e_de_size
e_xaa = 9 + e_de_size
e_yaa = 10 + e_de_size

e_spriteB_l = 11 + e_de_size
e_spriteB_h = 12 + e_de_size