;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Tank Ardad. A tank videogame.
;;  Copyright (C) 2018 Adrian Bardisa Serrano, Ariel Palma Arriaga, David Ruiz Falco
;;  abs90@alu.ua.es drf7@alu.ua.es acpa2@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "entity.h.s"
.include "main.h.s"
.include "colisions.h.s"
.include "movement.h.s"
.include "menu.h.s"
.include "map.h.s"

k_temporizador_bala = 10
k_max_num_ent = 5 ;numero maximo de entidades
k_entity_size = entity_vector0_size  ;tamaño de la entidad
k_tank_velocity_x = 1
k_tank_velocity_y = 2 
k_bala_velocity_x = 2
k_bala_velocity_y = 4

enemy_shot_constant = k_max_num_ent*k_entity_size+k_entity_size

entity_vector:
DefineNEntities entity_vector, k_max_num_ent

             ;_name,     _x,   _y,   _vx,  _vy,  _upd,             _eye, _sprite           _hp   temp  x_a   y_a   x_aa  y_aa
DefineEntity hero_data,  0x28, 0xB8, 0x00, 0x00, ent_moveKeyBoard, 0x03, _sprite_Hero_up,  0x03 ,0x00, 0x28, 0xB8, 0x28, 0xB8, _sprite_Hero_up2

entity_vector_shots:
DefineNEntities entity_vector_shots, k_max_num_ent
DefineEntity hero_shot,  0x28, 0xB8, 0x00, 0x00, ent_move_bala,    0x01, _sprite_Bullet_right,0x02, 0x00,0x28, 0xB8,0x28, 0xB8,0x0000

DefineEntity enemy_data, 0x20, 0x08, 0x01, 0x00, ent_move_3,         0x02, _sprite_Enemy3_right,  0x01,0x00,0x04, 0x08,0x04, 0x08,_sprite_Enemy3_right2
DefineEntity enemy_shot, 0x08, 0x08, 0x00, 0x00, ent_move_bala_enemy,    0x01, _sprite_Bullet_left,  0x04,0x00,0x08, 0x08,0x08, 0x08,0x0000


DefineEntity enemy_aux, 0x20, 0x16, 0x01, 0x00, ent_move_3,          0x02, _sprite_Enemy3_right,  0x01,0x00,0x04, 0x08,0x04, 0x08,_sprite_Enemy3_right2

DefineEntity hero_data_default,  0x28, 0xB8, 0x00, 0x00, ent_moveKeyBoard, 0x03, _sprite_Hero_up,  0x03,0x00, 0x28, 0xB8, 0x28, 0xB8,_sprite_Hero_up2
DefineEntity hero_shot_default,  0x28, 0xB8, 0x00, 0x00, ent_move_bala,    0x01, _sprite_Bullet_right,0x02,0x00, 0x28, 0xB8, 0x28, 0xB8,0x0000

m_entity_to_clean: .dw enemy_aux
m_num_ent: .db 00 ;numero de entidades
m_num_coordenada : .db 00
m_next_entity: .dw entity_vector ;puntero a entity vector, cuando alguien haga new, 
                        ;sera este mi siguiente posicion
m_next_entity_shot: .dw entity_vector_shots

ent_move_1:

ret


ent_es_par:

buclee:
    or a
    jr z, es_par  
    dec a
    jr z, es_impar
    dec a

    jp buclee
es_par:
    ld a, #1
    ret
es_impar:
    ld a, #-1
    ret

;; entry::  a->direccion del ojo
no_disparar_x:
    sub #2
    jr z, right_bullet

    ld a,#k_bala_velocity_x
    neg
    jr check_colision
right_bullet:
    ld a,#k_bala_velocity_x

check_colision:
    add de_x(ix)
    ld c,a
    call ent_bloque_eje_x
    ret


no_disparar_y:
    sub #1
    jr z, down_bullet
    ld a,#k_bala_velocity_y
    neg
    jr check_colision_y
down_bullet:
    ld a,#k_bala_velocity_y
check_colision_y:
    add de_y(ix)
    ld c,a
    call ent_bloque_eje_y
    ret
;;;;;;;;;;;;;;;;;;;;;;
;;entity move
;;INPUT: IX -> puntero a en

ent_move_generic:
    ld a,de_x(ix) ;;  cargamos las posiciones y las velocidades
    add e_vx(ix)
    ld de_x(ix),a

    ld a, de_y(ix) 
    add e_vy(ix)
    ld de_y(ix),a
ret






check_shot_eje_x_izquierda:
    call ent_bloque_eje_x
    or a
    jr nz,bloque_eje_x_izq
    ld h,#7
    ld l,#3
x_es_negativo:
    push hl
    ld a,de_x(ix)
    add l
    ld c,a
    ld a,de_y(ix)
    add h
    ld b,a
    ld a,(m_back_buffer)
    ld h,a
    ld l,#0
    ex de,hl
    push bc
    call cpct_getScreenPtr_asm
    call ent_get_next_pixel_right
    or a
    jr nz,encontrado_pixel
    call ent_get_next_pixel_left
    or a
    jr nz,encontrado_pixel
    pop bc
    pop hl
    dec h
    jr nz,x_es_negativo
    ld h,#7
    dec l
    jr nz,x_es_negativo
    jr no_encontrado_pixel
encontrado_pixel:
    pop bc
    pop hl
    call eliminar_enemigo
    or a
    jp m,encontrado_muro_izquierda
    ld b,a
    push ix
    call ent_borrar
    pop ix
    jr bloque_eje_x_izq
encontrado_muro_izquierda:
    call eliminar_bloque
bloque_eje_x_izq:
    ld a,#1
    ret
no_encontrado_pixel:
    ld a,#0
ret



check_shot_eje_x_derecha:
    
    call ent_bloque_eje_x
    or a
    jr nz,bloque_eje_x
    ld h,#7
    ld l,#0
x_es_positivo:
    push hl
    ld a,de_x(ix)
    add l
    ld c,a
    ld a,de_y(ix)
    add h
    ld b,a
    ld a,(m_back_buffer)
    ld h,a
    ld l,#0
    ex de,hl
    push bc
    call cpct_getScreenPtr_asm
    call ent_get_next_pixel_left
    or a
    jr nz,encontrado_pixel_der
    call ent_get_next_pixel_right
    or a
    jr nz,encontrado_pixel_der
    pop bc
    pop hl
    dec h
    jr nz,x_es_positivo
    ld h,#7
    inc l
    ld a,l
    sub #4
    jr nz,x_es_positivo
    jr no_encontrado_pixel_der
encontrado_pixel_der:
    pop bc
    pop hl
    call eliminar_enemigo
    or a
    jp m,encontrado_muro
    ld b,a
    push ix
    call ent_borrar
    pop ix
    jr bloque_eje_x
encontrado_muro:
    call eliminar_bloque
bloque_eje_x:
    ld a,#1
    ret
no_encontrado_pixel_der:
    ld a,#0
ret


check_shot_eje_y_up:
    call ent_bloque_eje_y
    or a
    jr nz,bloque_eje_y_up
    ld h,#7
y_es_negativo:
    push hl
    ld c,de_x(ix)
    ld a,de_y(ix)
    add h
    ld b,a
    ld a,(m_back_buffer)
    ld h,a
    ld l,#0
    ex de,hl
    push bc
    call cpct_getScreenPtr_asm
    call ent_get_next_pixel_up
    or a
    jr nz,encontrado_pixel_y_up
    pop bc
    pop hl
    dec h
    jr nz,y_es_negativo
    jr no_encontrado_pixel_y_up
encontrado_pixel_y_up:
    pop bc
    pop hl
    call encontrar_enemigo_eje_y
    or a
    jp m,encontrado_muro_y
    ld b,a
    push ix
    call ent_borrar
    pop ix
    jr bloque_eje_y_up
encontrado_muro_y:
    call eliminar_bloque
bloque_eje_y_up:
    ld a,#1
    ret
no_encontrado_pixel_y_up:
    ld a,#0
ret

    
check_shot_eje_y_down:
    call ent_bloque_eje_y
    or a
    jr nz,bloque_eje_y_down
    ld h,#0
y_down_es_negativo:
    push hl
    ld c,de_x(ix)
    ld a,de_y(ix)
    add h
    ld b,a
    ld a,(m_back_buffer)
    ld h,a
    ld l,#0
    ex de,hl
    push bc
    call cpct_getScreenPtr_asm
    call ent_get_next_pixel_up
    or a
    jr nz,encontrado_pixel_y_down
    pop bc
    pop hl
    inc h
    ld a,h
    sub #8
    jr nz,y_down_es_negativo
    jr no_encontrado_pixel_y_down
encontrado_pixel_y_down:
    pop bc
    pop hl
    call encontrar_enemigo_eje_y
    or a
    jp m,encontrado_muro_down
    ld b,a
    push ix
    call ent_borrar
    pop ix
    jr bloque_eje_y_down
encontrado_muro_down:
    call eliminar_bloque
bloque_eje_y_down:
    ld a,#1
    ret
no_encontrado_pixel_y_down:
    ld a,#0
ret

    


encontrar_enemigo_eje_y:
    ld a,(m_num_ent)
    or a
    jr z, no_enemigo_y
    ld hl, (m_next_entity)
    push hl
bucle_enemigo_y:
    push af
    push bc
    ld bc, #k_entity_size
    ld hl, (m_next_entity)
    or a
    sbc hl,bc 
    ld (m_next_entity), hl
    ld iy,(m_next_entity)
    ld h,de_y(iy)
    ld l,de_x(iy)

    pop bc

    ld a,e_hp(ix)
    sub #3
    jr nz,es_eje_down_y
    ld a,h
    sub b
    jp p,no_cambiar_valores_y
    neg
no_cambiar_valores_y:
    sub #8
    jp p,siguiente_enemy_y
    jr siguiente_eje_y
es_eje_down_y:
    ld a,h
    sub b
    jr nz,siguiente_enemy_y
    
siguiente_eje_y:
    ld a,c
    sub l
    jp p,no_cambiar_valor_x
    neg    
no_cambiar_valor_x:
    sub #4
    jp m,encontrado_enemy_y
siguiente_enemy_y:   
    pop af
    dec a
    jr nz,bucle_enemigo_y
    jr no_enemigo_y
encontrado_enemy_y:
    pop af
    pop hl
    ld (m_next_entity),hl
    ret
no_enemigo_y:

    pop hl
    ld (m_next_entity),hl
    ld a,#0xFF
ret


ret
;;; bc -->enemigo eje

eliminar_enemigo:
    ld a,(m_num_ent)
    or a
    jr z, no_enemigo
    ld hl, (m_next_entity)
    push hl
bucle_enemigo:
    push af
    push bc
    ld bc, #k_entity_size
    ld hl, (m_next_entity)
    or a
    sbc hl,bc 
    ld (m_next_entity), hl
    ld iy,(m_next_entity)
    ld h,de_y(iy)
    ld l,de_x(iy)

    pop bc

    ld a,e_hp(ix)
    sub #4
    jr nz,es_eje_derecha
    ld a,l
    sub c
    jp p,no_cambiar_valores
    neg
no_cambiar_valores:
    sub #4
    jp p,siguiente_enemy 
    jr siguiente_eje
es_eje_derecha:
    ld a,c
    sub l
    jr nz,siguiente_enemy
    
siguiente_eje:
    ld a,b
    sub h
    jp p,no_cambiar_valor
    neg    
no_cambiar_valor:
    sub #8
    jp m,encontrado_enemy
siguiente_enemy:   
    pop af
    dec a
    jr nz,bucle_enemigo
    jr no_enemigo
encontrado_enemy:
    pop af
    pop hl
    ld (m_next_entity),hl
    ret
no_enemigo:

    pop hl
    ld (m_next_entity),hl
    ld a,#0xFF
ret




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Al pulsar la tecla Barra Espaciadora dibuja la entidad shot
;; REGISTROS DESTRUIDOS: A, BC, IX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_shot:
    ld ix,#hero_data

    ld a, e_tmp(ix)
    or a
    jr z, dispar
        ret
dispar:
    ld e_tmp(ix), #0x10

    ld b, de_y(ix)
    ld c, e_eye(ix)
    ld a, de_x(ix) 

    ld ix, #hero_shot
    ld h, de_y(ix)
    ld l, de_x(ix)
    push hl 
    ld e_hp(ix), c
    ld e_eye(ix), #0 ;Si eye(ix)=0 significa que la bala se esta disparando
    ld de_x(ix),a
    ld de_y(ix),b

    dec c
    jr z, abajo     ;La bala se dispara hacia abajo
    dec c
    jr z, derecha   ;La bala se dispara hacia la derecha
    dec c
    jr z, arriba    ;La bala se dispara hacia arriba
    dec c
    jr z, izquierda ;La bala se dispara hacia la izquierda


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Modifica shot para que mire hacia donde vaya
;; REGISTROS DESTRUIDOS: A, HL
;; ENTRADA: IX -> puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
abajo:
    
    ld a, de_y(ix)
    add #8          ;; Le sumamos 8 para que la bala salga una posicion mas abajo que el tanque
    ld de_y(ix), a
    ld c,a
    ;call check_shot_eje_y
    call check_shot_eje_y_down
    or a
    jp nz,no_dibujar_shot
    ld e_vx(ix), #0x00 ;; Actualizamos velocidad de la bala
    ld e_vy(ix), #k_bala_velocity_y ;; ""
    ld hl, #_sprite_Bullet_down ;; Cargamos sprite de la bala en hl
    ld de_sprite_h(ix), h ;; Guardamos el sprite en la entidad
    ld de_sprite_l(ix), l ;; ""
    jr dibujar_shot
derecha:
    
    add #4          ;; Le sumamos 4 para que la bala salga una posicion mas a la derecha que el tanque
    ld de_x(ix),a
    ld c,a
    ;call ent_bloque_eje_x
    call check_shot_eje_x_derecha
    or a
    jr nz,no_dibujar_shot
    ld e_vx(ix), #k_bala_velocity_x
    ld e_vy(ix), #0x00
    ld hl, #_sprite_Bullet_right
    ld de_sprite_h(ix), h
    ld de_sprite_l(ix), l


    jr dibujar_shot
arriba:
    
    ld a, de_y(ix)
    add #-8         ;; Le restamos 8 para que la bala salga una posicion mas arriba que el tanque
    ld de_y(ix), a
    ld c,a
    ;call check_shot_eje_y
    call check_shot_eje_y_up
    or a
    jr nz,no_dibujar_shot
    ld a,#k_bala_velocity_y
    neg
    ld e_vy(ix), a
    ld e_vx(ix), #0x00
    ld hl, #_sprite_Bullet_up
    ld de_sprite_h(ix), h
    ld de_sprite_l(ix), l

    jr dibujar_shot
izquierda:
    
    add #-4         ;; Le restamos 4 para que la bala salga una posicion mas a la izquierda que el tanque
    ld de_x(ix),a
    ld c,a
    ld a,#-1
    call check_shot_eje_x_izquierda

    or a
    jr nz,no_dibujar_shot
    ld a,#k_bala_velocity_x
    neg
    ld e_vx(ix), a
    ld e_vy(ix), #0x00
    ld hl, #_sprite_Bullet_left
    ld de_sprite_h(ix), h
    ld de_sprite_l(ix), l

dibujar_shot:
    call ent_draw
    call ren_updateEntity
    pop hl
    jr return_shoot
no_dibujar_shot:
    pop hl 
    ld de_x(ix),l
    ld de_y(ix),h
    ld a,e_hp(ix)
    ld e_eye(ix),a
return_shoot:
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Borra una entidad, disminuye en 1 el num de entidades
;; REGISTROS DESTRUIDOS: AF, BC, HL
;; ENTRADA: B -> numero de entidad a borrar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_borrar:
    ld a, (m_num_ent)
    or a
    jr z, no_hay_para_borrar
    sub b
    
    ld bc, #k_entity_size
    ld hl, (m_next_entity)
    sbc hl,bc ;voy bajando por el vector, restandole una entidad

    ld (m_next_entity), hl ;le bajo uno al puntero

    ex de,hl ;tengo en de el puntero a la ultima entidad creada
    ld hl, (m_next_entity)
    inc a
bucle:
    dec a
    jr z, copiar
    sbc hl,bc
    jr bucle
copiar:

    push hl
    push de
    ex de,hl  ;; aqui en de tengo el origen
    ld hl,(m_entity_to_clean)  ;; destino
    ex de,hl

    push ix
    push hl
    push hl
    pop ix
    call init_explosion
    pop hl
    pop ix

    call ent_copy
    pop de
    pop hl

    ex de,hl ;pongo en hl la entidad origen, y en de la entidad destino    
    call ent_copy ;copio en la entidad que borro la ultima

    ld hl,(m_next_entity)
    ex de,hl
    ld hl,(m_entity_to_clean)
    call ent_copy

    ld ix,(m_next_entity)
    call ren_clear_backbuffer
    call ren_clear_frontbuffer

    ld a, (m_num_ent) ;decremento el numero de entidades en 1
    dec a
    ld (m_num_ent), a
    
no_hay_para_borrar:

    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; REGISTRA UNA NUEVA ENTIDAD
;; REGISTROS DESTRUIDOS: AF, BC, HL
;; SALIDA: HL -> puntero a la nueva entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_new:
    ld a, (m_num_ent) ;Cargo el numero de entidades actuales
    ld c, #k_max_num_ent
    cp c
    jr z, max_num_entity ;Comprueba que no se sobrepasen el numero de entidades máximas
    inc a             ;Incremento el numero de entidades en 1 ya que voy a crear una nueva
    ld (m_num_ent),a  ;Actualizo el valor de m_num_ent

    ld hl, (m_next_entity) ;cargo puntero en hl (sin parentesis seria donde esta m_next_entity, no dnde apunta)
    ld bc, #k_entity_size
    add hl, bc ;suma de 16 bits, para no preocuparse de acarreos
    ld (m_next_entity), hl; actualizo el valor de m_next_entity a la siguiente
    or a ;pongo acarreo a 0
    sbc hl,bc ;resto con acarreo para tener en hl apuntando a la nueva entidad creada

max_num_entity:

    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COPIA LOS VALORES DE UNA ENTIDAD SOBRE OTRA
;; REGISTROS DESTRUIDOS: 
;; ENTRADA: 
;;      HL -> entidad origen 
;;      DE -> entidad destino
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_copy:
    ld bc, #k_entity_size
    ldir ; asume que HL esta apuntando a un sitio en memoria y DE en otro,
         ; y BC contiene un tamaño va leyendo de HL y copiando en DE y aumentando 
         ; hasta que BC llega a 0

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; HACER ALGO PARA TODAS LAS ENTIDADES
;; REGISTROS DESTRUIDOS: 
;; ENTRADA: HL -> puntero al metodo a ejecutar
;;          IX -> Puntero a vector de entidades
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_doForAll:
    ld a, (m_num_ent)
    or a
    jr z, empty_vector ; Comprueba si hay 0 entidades en el vector
    ld (metodo), hl
    push ix ;;Guardamos el valor de ix inicial
buc:

    push af

    metodo = . + 1 ;direccion de memoria donde estoy + 1, o sea donde esta la direcion de ent_draw
    call ent_draw ;codigo automodificable

    pop af
    ld bc, #k_entity_size ;Apuntamos a la siguiente entidad
    add ix, bc

    dec a
    jr nz,buc
     pop ix ;;Recuperamos el valor de ix inicial
empty_vector:
   
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;hero get position pointer
;; ENTRY = ix
;; DESTROY = IX , A 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
hero_getPointerHL:
    ld hl,#hero_data ;; carga la direccion de hero_x
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;entity update 
;;INPUT: 
;;DESTROYS: hl,bc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ent_update:
    
    ld      h,e_up_h(ix)
    ld      l,e_up_l(ix)
    ld      bc, #aqui2        ;; asi hacemos que salte a aqui,  para que regrese
    push    bc 
    jp      (hl)             ;;; hayque tener en cuenta que si solo dejamos esta linea no volveria
aqui2:
    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;entity Draw 
;;INPUT: IX -> puntero a entidad
;;DESTROYS: BC, DE, HL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ent_draw:
    call ren_drawEntity
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;entity update and draw shoot 
;;INPUT: IX -> puntero a entidad
;;DESTROYS: A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ent_update_draw_shoot:
    
    ld a, e_eye(ix)
    or a
    jr nz, not_shooting  ;; Si e_eye(ix)=0 significa que no esta disparando
    ;call ren_clear_backbuffer
    call ent_update
    or a
    jr nz,not_colision_bala
    ;call ren_updateEntity
    call ent_draw
    ret
not_colision_bala:

not_shooting:
    

ret
 


comprobar_colision_bala_wall:
    ld a,e_vx(ix)
    or e_vy(ix)
    call comprobar_colision
    ret


restar_hp_tank:
    ld iy,#hero_data

    ld a,de_y(ix)                ;;; C=entity y
    add e_vy(ix)
    ld h,a
    ld a,de_x(ix)                ;;; C=entity x
    add e_vx(ix)
    ld l,a
    ld d,de_y(iy)
    ld e,de_x(iy)
    ld a,e_vx(ix)
    or e_vy(ix)


    jp m,comprobar_cambio_vida
    ex de,hl
comprobar_cambio_vida:
    call get_velocitat
    or a
    jr z,es_y_cambiar_x_vida
    call cambiar_y
    jr no_cambiar_ejes
es_y_cambiar_x_vida:
    call cambiar_x
no_cambiar_ejes:
    push ix
    sbc hl,de
    jp m,no_restar
    or a
    ld d,h
    ld e,l

    ld bc,#0x0008
    ld l,d
    ld h,#0x00
    sbc hl,bc
    jp p,no_restar
    or a
    ld bc,#0x0004
    ld h,#0x00
    ld l,e
    sbc hl,bc
    jp p,no_restar

    jr encontrado_heroe

encontrado_heroe:
    ld a,e_hp(iy)
    dec a
    ld e_hp(iy),a
    jr z, cero_vidas
    dec a
    jr z, una_vidas
    dec a
    jr z, dos_vidas
cero_vidas:
    ld ix, #hearth_one
    ld hl, #_sprite_hearthEmpty
    call cambiar_sprite
    call ren_drawEntity
    call ren_drawEntity_front
    jr no_restar
una_vidas:
    ld ix, #hearth_two
    ld hl, #_sprite_hearthEmpty
    call cambiar_sprite
    call ren_drawEntity
    call ren_drawEntity_front
    jr no_restar
dos_vidas:
    ld ix, #hearth_three
    ld hl, #_sprite_hearthEmpty
    call cambiar_sprite
    call ren_drawEntity
    call ren_drawEntity_front
no_restar:
    pop ix
    ld a,e_hp(iy)
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;entity move
;;INPUT: IX -> puntero a entidad
;;DESTROYS: a
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move_bala_enemy:
    call comprobar_colision_bala_wall
    or a
    jr nz,comprobar_tank_hero
    ld a,de_x(ix)
    add e_vx(ix)
    ld de_x(ix),a

    ld a,de_y(ix)
    add e_vy(ix)
    ld de_y(ix),a

    ld a,#0
    jr end_move_bala_enemy
comprobar_tank_hero:

    call restar_hp_tank
    call comprobar_limites
    or a
    jr nz,reiniciar_bala
    call eliminar_bloque
    jr reiniciar_bala  
reiniciar_bala_enemy:
    ld a,#1
    ld e_eye(ix),a
    ld a,#0
    ld e_vy(ix),a
    ld e_vx(ix),a
    ld a,#1
end_move_bala_enemy:
    
    ret

comprobamos_toda_colision:
    call comprobar_colision_bala_wall
    or a
    jr nz,comprobar_si_es_tank
    ld a,#0
    jr end_toda_colision
comprobar_si_es_tank:

    call get_entity_colision_x
    or a
    jr nz,colision_bala_tank
    call comprobar_limites
    or a
    jr nz,reiniciar_bala
    call comprobar_si_es_bala
    or a
    jr nz,reiniciar_bala
    call eliminar_bloque
    jr reiniciar_bala  
colision_bala_tank:
    push ix
    ld b,a
    call ent_borrar
    pop ix
reiniciar_bala:
    ld a,#1
    ld e_eye(ix),a
    ld a,#0
    ld e_vy(ix),a
    ld e_vx(ix),a
    ld a,#1
end_toda_colision:
    ret


comprobar_si_es_bala:
    ld a,#k_max_num_ent
    ld hl, (m_next_entity_shot)
    push hl
bucle_shot:
    push af
    ld bc, #k_entity_size
    ld hl, (m_next_entity_shot)
    or a
    sbc hl,bc 
    ld (m_next_entity_shot), hl
    ld iy,(m_next_entity_shot)

           ;;;Comienzo la memoria de video
    ld a,e_eye(iy)
    jr z,siguiente_shot

    ld a,de_y(ix)                ;;; C=entity y
    add e_vy(ix)
    ld h,a
    ld a,de_x(ix)                ;;; C=entity x
    add e_vx(ix)
    ld l,a
    ld d,de_y(iy)
    ld e,de_x(iy)
    ld a,e_vx(ix)
    or e_vy(ix)


    jp m,comprobar_eje_shot
    ex de,hl
comprobar_eje_shot:
    call get_eje_shot
    or a
    jr z,cambiar_eje_shot_x
    call cambiar_y
    jr no_cambiar_shot
cambiar_eje_shot_x:
    call cambiar_x
no_cambiar_shot:
    sbc hl,de
    jp m,siguiente_shot
    or a
    ld d,h
    ld e,l

    ld bc,#0x0008
    ld l,d
    ld h,#0x00
    sbc hl,bc
    jp p,siguiente_shot
    or a
    ld bc,#0x0004
    ld h,#0x00
    ld l,e
    sbc hl,bc
    ;ld a, l
    ;sub c
    jp p,siguiente_shot

    jr encontrado_shot
siguiente_shot:
    pop af
    dec a
    jr nz,bucle_shot
    jr no_es_shot
encontrado_shot:
    ld a,e_hp(iy)
    dec a
    ld e_hp(iy),a
    call init_explosion
    pop af
    pop hl
    ld (m_next_entity_shot),hl
    ret
no_es_shot:
    pop hl
    ld (m_next_entity_shot),hl
    ld a,#0x00
   ret



ent_move_bala:
    call comprobamos_toda_colision
    or a
    jr nz,comprobamos_ok_colision
    ld a,de_x(ix)
    add e_vx(ix)
    ld de_x(ix),a

    ld a,de_y(ix)
    add e_vy(ix)
    ld de_y(ix),a

    ld a,#0
    jr end_move_bala
comprobamos_ok_colision:
    ld a,#1

end_move_bala:
    
    ret



comprobar_limites:

    
    call get_eje_shot
    or a
    jr z,es_y_bala
    ;push ix
    ;ld bc, #enemy_shot_constant
    ;add ix, bc
    ld a, e_hp(ix)
    ;pop ix
    call no_disparar_x
    jr comprobar_shoot_bala
es_y_bala:
    ;push ix
    ;ld bc, #enemy_shot_constant
    ;add ix, bc
    ld a, e_hp(ix)
    ;pop ix
    call no_disparar_y

comprobar_shoot_bala:
    or a
    ret

;; cambiar para que pinte tiles
eliminar_bloque:
    ;;call ent_new
    ;;push hl
    ld a,(m_back_buffer)
    ld d,a
    ld e, #0x00      ;;Comienzo memoria de video
    ld a,de_x(ix) 
    add e_vx(ix)  
    ld c, a        ;; C = Entity x
    
    ld a,de_y(ix) 
    add e_vy(ix)  
    ld b, a         ;; B = Entity y
    
    ;ld c, de_x(ix)     ;; C = Entity x
    ;ld b, de_y(ix)       ;; C = Entity y

    call cpct_getScreenPtr_asm

    ex de, hl   ;; DE = Puntero a memoria
    ld a, #0x00  ;; Color
    ld bc,#0x0804 ; b=alto, c=ancho
    call cpct_drawSolidBox_asm

    ld a,(m_front_buffer)
    ld d,a
    ld e, #0x00      ;;Comienzo memoria de video
    ld a,de_x(ix) 
    add e_vx(ix)  
    ld c, a        ;; C = Entity x
    
    ld a,de_y(ix) 
    add e_vy(ix)  
    ld b, a         ;; B = Entity y
    
    ;ld c, de_x(ix)     ;; C = Entity x
    ;ld b, de_y(ix)       ;; C = Entity y

    call cpct_getScreenPtr_asm

    ex de, hl   ;; DE = Puntero a memoria
    ld a, #0x00  ;; Color
    ld bc,#0x0804 ; b=alto, c=ancho
    call cpct_drawSolidBox_asm
ret



cambiar_y:
    
    ld a,h
    sub d
    jp p,no_cambiar_y
    ld a,h
    ld h,d
    ld d,a
no_cambiar_y:

ret
cambiar_x:
    ld a,l
    sub e
    jp p,no_cambiar_x
    ld a,l
    ld l,e
    ld e,a
no_cambiar_x:
ret

get_entity_colision_x:
    ld a,(m_num_ent)
    or a
    jr z, no_hay_tank
    ld hl, (m_next_entity)
    push hl
bucle_tank:
    push af
    ld bc, #k_entity_size
    ld hl, (m_next_entity)
    or a
    sbc hl,bc 
    ld (m_next_entity), hl
    ld iy,(m_next_entity)

           ;;;Comienzo la memoria de video


    ld a,de_y(ix)                ;;; C=entity y
    add e_vy(ix)
    ld h,a
    ld a,de_x(ix)                ;;; C=entity x
    add e_vx(ix)
    ld l,a
    ld d,de_y(iy)
    ld e,de_x(iy)
    ld a,e_vx(ix)
    or e_vy(ix)


    jp m,comprobar_cambio
    ex de,hl
comprobar_cambio:
    call get_eje_shot
    or a
    jr z,es_y_cambiar_x
    call cambiar_y
    jr no_cambiar
es_y_cambiar_x:
    call cambiar_x
no_cambiar:
    sbc hl,de
    jp m,es_negativo
    or a
    ld d,h
    ld e,l

    ld bc,#0x0008
    ld l,d
    ld h,#0x00
    sbc hl,bc
    jp p,es_negativo
    or a
    ld bc,#0x0004
    ld h,#0x00
    ld l,e
    sbc hl,bc
    ;ld a, l
    ;sub c
    jp p,es_negativo

    jr encontrado_entidad
es_negativo:
    pop af
    dec a
    jr nz,bucle_tank
    jr no_es_tank
encontrado_entidad:
    ld a,e_hp(iy)
    dec a
    ld e_hp(iy),a
    pop af
    pop hl
    ld (m_next_entity),hl
    ret
no_es_tank:
    pop hl
    ld (m_next_entity),hl
no_hay_tank:
    ld a,#0x00
   ret



get_eje_shot:
    ld a,e_hp(ix)
    sub #1
    jr z,eje_y_v
    sub #2
    jr z,eje_y_v
    ld a,#1
    jr end_eje_shot
eje_y_shot:
    ld a,#0
end_eje_shot:
    ret

get_velocitat:
    ld a,e_eye(ix)
    or a
    jr z,es_bala
    ld a,e_vx(ix)
    or a
    jr z,eje_y_v
    ld a,#1
    ret
eje_y_v:
    ld a,#0
    ret
es_bala:
    call get_eje_shot
    ret



cambiar_velocidad_asociado_bala:
    or a
    jr z, no_cambiar_velocidad
    ld e_vx(ix),#0
    ld e_vy(ix),#1
    dec a
    jr z,no_cambiar_velocidad ;;;;a=1
    ld e_vx(ix),#1
    ld e_vy(ix),#0
    dec a
    jr z,no_cambiar_velocidad ;;;;a=2
    ld e_vx(ix),#0
    ld e_vy(ix),#-1
    
    dec a
    jr z,no_cambiar_velocidad  ;;;;a=3
    ld e_vx(ix),#-1
    ld e_vy(ix),#0
    ld a,#1
    ret
no_cambiar_velocidad:
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dispara si ve un disparo en su eje y se sta moviendo en ese eje
;; INPUT: IX -> puntero a entidad
;; REGISTROS DESTRUIDOS: A, B,
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
shottoshot:
    ld iy,#hero_shot
    ld a, e_eye(iy)
    or a
    jr z, disparo_en_partida
    ret
disparo_en_partida:
    ;ld a, e_vx(ix)
    ;ld b, e_vx(iy)
    ;add b
    ;jr z, van_a_chocar
        ;ld a, e_vy(ix)
        ;ld b, e_vy(ix)
        ;add b
        ;jr z, van_a_chocar
          ;  ret
van_a_chocar:
    ld a, #1
    ex AF, AF'
    jp ent_enemy_shottoshot

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;entity move
;;INPUT: IX -> puntero a entidad
;;DESTROYS: a
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move_3:
    push ix
    ld bc, #enemy_shot_constant
    add ix, bc
    ld a, e_eye(ix)
    or a
    pop ix
    jr z, is_already_shooting_3

    call cpct_getRandom_mxor_u8_asm
    ld a,l
    call modulo4
    or a
    jr z, asd_3
        call cpct_getRandom_mxor_u8_asm
    ld a,l
    call modulo4
    or a
    jr z, asd_3
    call pat_movement
asd_3:
    ;call shottoshot
  ;; Si e_eye(ix)=0 significa que se esta disparando
    call distancia_x
    or a
    jr z, hacer_nada_3
    call distancia_y
    or a
    jr z, hacer_nada_3 ; Generar num aleatorio y que a veces te busque en el eje x,y
            ld bc, #enemy_shot_constant
            add ix, bc ;; Cargo en ix la bala del enemy tank
            ld a, e_tmp(ix)
            or a
        jr z, puede_disparar3
            dec a
        ret
puede_disparar3:
    ld bc, #-enemy_shot_constant
    add ix,bc
    call cpct_getRandom_mxor_u8_asm
    ld a,l
    call modulo4
    or a
    jr z, asdd
    ret
asdd:
    call cpct_getRandom_mxor_u8_asm
    ld a,l
    call modulo4
    or a
    jr z, asde
    ret
asde:       
        call ent_enemy_shot
        call cambiar_velocidad_asociado_bala


ret
is_already_shooting_3:

    jp ent_move_hero

hacer_nada_3:
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;entity move
;;INPUT: IX -> puntero a entidad
;;DESTROYS: a
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move_2:
    push ix
    ld bc, #enemy_shot_constant
    add ix, bc
    ld a, e_eye(ix)
    or a
    pop ix
    jr z, is_already_shooting_2

    call cpct_getRandom_mxor_u8_asm
    ld a,l
    call modulo4
    or a
    jr z, asd
    call pat_movement
asd_2:
    ;call shottoshot
  ;; Si e_eye(ix)=0 significa que se esta disparando
    call distancia_x_2
    or a
    jr z, hacer_nada_2
    call distancia_y_2
    or a
    jr z, hacer_nada_2 ; Generar num aleatorio y que a veces te busque en el eje x,y
            ld bc, #enemy_shot_constant
            add ix, bc ;; Cargo en ix la bala del enemy tank
            ld a, e_tmp(ix)
            or a
        jr z, puede_disparar
            sub #3
        ret
puede_disparar:
        ld bc, #-enemy_shot_constant
        add ix,bc
        call ent_enemy_shot
        call cambiar_velocidad_asociado_bala


ret
is_already_shooting_2:

    jp ent_move_hero

hacer_nada_2:
ret

ent_move:
    push ix
    ld bc, #enemy_shot_constant
    add ix, bc
    ld a, e_eye(ix)
    or a
    pop ix
    jr z, is_already_shooting

    call cpct_getRandom_mxor_u8_asm
    ld a,l
    call modulo4
    or a
    jr z, asd
    call pat_movement
asd:
    ;call shottoshot
  ;; Si e_eye(ix)=0 significa que se esta disparando
    call distancia_x
    or a
    jr z, hacer_nada
    call distancia_y
    or a
    jr z, hacer_nada ; Generar num aleatorio y que a veces te busque en el eje x,y
            ld bc, #enemy_shot_constant
            add ix, bc ;; Cargo en ix la bala del enemy tank
            ld a, e_tmp(ix)
            or a
        jr z, puede_disparar_2
            dec a
        ret
puede_disparar_2:
        ld bc, #-enemy_shot_constant
        add ix,bc
        ;call shottoshot
        call ent_enemy_shot
        call cambiar_velocidad_asociado_bala


ret
is_already_shooting:

    jp ent_move_hero

hacer_nada:
ret

;;x  y
;;04 08 ;;04 B8
;;20 08 ;;48 B8
;;2B 08 ;;04 08
;;48 08 ;;48 08
init_enemy:
    ld ix,#enemy_data
    ld de_x(ix), b
    ld de_y(ix), c
ret

m_next_position: .dw enemies_positions
k_max_enemies: .db 0x04
m_current_position:.db 0x00
enemies_positions: .dw 0x04B8 
                   .dw 0x48B8
                   .dw 0x0408
                   .dw 0x4808
k_enemies_positions = 3
enemies_per_level: .db 0x00  
k_enemies_per_level = 2 ;;Habria que sumarle los enemigos iniciales (initializee_enemy_map)
                        ;;para saber el numero de enemigos totales por nivel
k_enemies_per_level2 = 5
k_enemies_per_level3 = 6
k_enemies_per_level4 = 10                           
respawn_enemies:
    ;;Comprobamos que no haya ya 4 enemigos en el nivel
    ld a, (m_num_ent)
    push af
    ld a, (k_max_enemies)
    push af
    pop bc
    pop af
    cp b
    jr z,no_more_enemies
    ;;Comprobamos que no se ha llegado al limite de enemigos por nivel
    ld a, (enemies_per_level)
    or a
    jr z,no_more_enemies
    ;;Añadimos un nuevo enemy
    dec a
    ld (enemies_per_level), a
    
    ld ix, (m_next_position)
    ld b, 1(ix)
    ld c, 0(ix)

    call init_enemy
    call create_enemy

    ld hl, (m_next_position)
    ld bc, #2
    add hl, bc
    ld (m_next_position), hl;
    ld a, (m_current_position)
    inc a
    ld (m_current_position), a

    ld b, #k_enemies_positions
    cp b
    jr nz, no_more_enemies

    ld hl, #enemies_positions
    ld (m_next_position), hl
    ld a, #0
    ld (m_current_position), a
no_more_enemies:
ret

initialize_enemies_map4:
    push af
    ld a, #k_enemies_per_level4
    ld (enemies_per_level), a
    ld a, #5
    ld (k_max_enemies), a
    ld ix,#enemy_data
    ld de_x(ix), #0x04
    ld de_y(ix), #0x08
    call create_enemy
    ld ix,#enemy_data
    ld de_x(ix), #0x20
    call create_enemy
    ld ix,#enemy_data
    ld de_x(ix), #0x2B
    call create_enemy
    ld ix,#enemy_data
    ld de_x(ix), #0x48
    call create_enemy
    ld ix,#enemy_data
    ld de_x(ix), #0x04
    ld de_y(ix), #0x60
    call create_enemy
    pop af
ret

initialize_enemies_map3:
    push af
    ld a, #k_enemies_per_level3
    ld (enemies_per_level), a
    ld a, #4
    ld (k_max_enemies), a
    ld ix,#enemy_data
    ld de_x(ix), #0x04
    ld de_y(ix), #0x08
    call create_enemy
    ld ix,#enemy_data
    ld de_x(ix), #0x20
    call create_enemy
    ld ix,#enemy_data
    ld de_x(ix), #0x2B
    call create_enemy
    ld ix,#enemy_data
    ld de_x(ix), #0x48
    call create_enemy
    pop af
ret

initialize_enemies_map2:
    push af
    ld a, #k_enemies_per_level2
    ld (enemies_per_level), a
    ld a, #3
    ld (k_max_enemies), a
    ld ix,#enemy_data
    ld de_x(ix), #0x04
    ld de_y(ix), #0x08
    call create_enemy
    ld ix,#enemy_data
    ld de_x(ix), #0x20
    call create_enemy
    ld ix,#enemy_data
    ld de_x(ix), #0x2B
    call create_enemy
    pop af
ret

initialize_enemies_map1:
    push af
    ld a, #k_enemies_per_level
    ld (enemies_per_level), a
    ld a, #2
    ld (k_max_enemies), a
    ld ix,#enemy_data
    ld de_x(ix), #0x04
    ld de_y(ix), #0x08
    call create_enemy
    ld ix,#enemy_data
    ld de_x(ix), #0x48
    call create_enemy
    pop af
ret

create_enemy:
    call ent_new
    push hl
    ex de,hl
    ld hl,#enemy_data
    call ent_copy
    pop hl
    ld bc, #enemy_shot_constant
    add hl, bc
    ex de, hl
    ld hl, #enemy_shot
    call ent_copy
ret

cambiar_sprite:
    ld de_sprite_h(ix),h
    ld de_sprite_l(ix),l
ret

cambiar_spriteB:
   ld e_spriteB_h(ix), h
   ld e_spriteB_l(ix), l
ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;entity enemy shot
;;INPUT: IX -> puntero a entidad
;;DESTROYS: DE, AB, HL, IX, IY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_enemy_shot:
    ld e_tmp(ix),#0x15
    push ix
    ;;IX enemy data
    ld e,de_y(ix) ;; Nos hara falta guardar la x e y del enemy
    ld d,de_x(ix) ;; para saber desde donde disparar la bala luego

    ld iy, #hero_data
enemy_shott:
    ld a,de_x(iy)
    ld b,de_x(ix)
    
    sub b
    jr z,mismo_eje_x
    ;add #3
    ;jr z,mismo_eje_x
    ;add #-6
    ;jr z,mismo_eje_x


    ld a,de_y(ix)
    ld b,de_y(iy)

    sub b
    jp z,mismo_eje_y
    ;add #3
    ;jp z,mismo_eje_y
    ;add #-6
    ;jp z,mismo_eje_y

    ld a,#0
    jp exit_enemy_shot ;;Distinto eje X y eje Y
mismo_eje_x:
    ld a,de_y(ix)
    ld b,de_y(iy)
    cp b
    jp c,yEnemy_menor_yHero
    ;cargar enemy sprite mirando hacia arriba
    ;disparar hacia arriba
    SpriteEnemyUp = . + 1
    ld hl, #_sprite_Enemy3_up
    call cambiar_sprite
    SpriteEnemyUp2 = . + 1
    ld hl, #_sprite_Enemy3_up2
    call cambiar_spriteB
    ld e_eye(ix),#3

    ld bc, #enemy_shot_constant
    add ix, bc ;; Cargo en ix la bala del enemy tank

    ld e_tmp(ix),#0x20
    ld e_eye(ix), #0 ;Si eye(ix)=0 significa que la bala se esta disparando
    ld de_x(ix),d
    ld de_y(ix),e
    ld e_hp(ix),#3
    ld a, de_y(ix)
    add #-8         ;; Le restamos 8 para que la bala salga una posicion mas arriba que el tanque
    ld de_y(ix), a
    ld e_vx(ix), #0x00
    ld e_vy(ix), #0xFD

    ld hl, #_sprite_Bullet_up
    call cambiar_sprite
    ld a,#3
    jp exit_enemy_shot
yEnemy_menor_yHero:
    ;cargar enemy sprite mirando hacia abajo
    ;disparar hacia abajo
    SpriteEnemyDown = . + 1
    ld hl, #_sprite_Enemy3_down
    call cambiar_sprite
    SpriteEnemyDown2 = . + 1
    ld hl, #_sprite_Enemy3_down2
    call cambiar_spriteB
    ld e_eye(ix),#1
    ld bc, #enemy_shot_constant
    add ix, bc ;; Cargo en ix la bala del enemy tank

        ld e_tmp(ix),#0x20
    ld e_eye(ix), #0 ;Si eye(ix)=0 significa que la bala se esta disparando
    ld de_x(ix),d
    ld de_y(ix),e
    ld e_hp(ix),#1
    ld a, de_y(ix)
    add #8          ;; Le sumamos 8 para que la bala salga una posicion mas abajo que el tanque
    ld de_y(ix), a
    ld e_vx(ix), #0x00 ;; Actualizamos velocidad de la bala
    ld e_vy(ix), #0x03 ;; ""
    ld hl, #_sprite_Bullet_down ;; Cargamos sprite de la bala en hl
    call cambiar_sprite
        ld a,#1
jp exit_enemy_shot
mismo_eje_y:
    ld a,de_x(iy)
    ld b,de_x(ix)
    cp b
    jp c,xEnemy_menor_xHero
    ;cargar enemy sprite mirando hacia izquierda
    ;disparar hacia izquierda
    ;Derecha
    SpriteEnemyRight = . + 1
    ld hl, #_sprite_Enemy3_right
    call cambiar_sprite
    SpriteEnemyRight2 = . + 1
    ld hl, #_sprite_Enemy3_right2
    call cambiar_spriteB

    ld e_eye(ix),#2
    ld bc, #enemy_shot_constant
    add ix, bc ;; Cargo en ix la bala del enemy tank

    ld e_tmp(ix),#0x20
    ld e_eye(ix), #0 ;Si eye(ix)=0 significa que la bala se esta disparando
    ld de_x(ix),d
    ld de_y(ix),e
    ld e_hp(ix),#2
    ld a, de_x(ix)
    add #4          ;; Le sumamos 4 para que la bala salga una posicion mas a la derecha que el tanque
    ld de_x(ix),a
    ld e_vx(ix), #0x02
    ld e_vy(ix), #0x00
    ld hl, #_sprite_Bullet_right
    call cambiar_sprite
    ld a,#2
    jp exit_enemy_shot
xEnemy_menor_xHero:
    ;cargar enemy sprite mirando hacia derecha
    ;disparar hacia derecha
    ;Izquierda
    ld e_vy(iy),#0
    SpriteEnemyLeft = . + 1
    ld hl, #_sprite_Enemy3_left
    call cambiar_sprite
    SpriteEnemyLeft2 = . + 1
    ld hl, #_sprite_Enemy3_left2
    call cambiar_spriteB

    ld e_eye(ix),#4
    ld bc, #enemy_shot_constant
    add ix, bc ;; Cargo en ix la bala del enemy tank

    ld e_tmp(ix),#0x20
    ld e_eye(ix), #0 ;Si eye(ix)=0 significa que la bala se esta disparando
    ld de_x(ix),d
    ld de_y(ix),e
    ld e_hp(ix),#4
    ld a, de_x(ix)
    add #-4         ;; Le restamos 4 para que la bala salga una posicion mas a la izquierda que el tanque
    ld de_x(ix),a
    ld e_vx(ix), #0xFE
    ld e_vy(ix), #0x00
    ld hl, #_sprite_Bullet_left
    call cambiar_sprite
    ld a,#4
    jp exit_enemy_shot
exit_enemy_shot:
    pop ix
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;entity enemy shot
;;INPUT: IX -> puntero a entidad
;;DESTROYS: DE, AB, HL, IX, IY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_enemy_shottoshot:

    ld e_tmp(ix),#0x08
    push ix
    ;;IX enemy data
    ld e,de_y(ix) ;; Nos hara falta guardar la x e y del enemy
    ld d,de_x(ix) ;; para saber desde donde disparar la bala luego

    ld iy, #hero_shot

    jp enemy_shott

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;entity move
;;INPUT: IX -> puntero a entidad
;;DESTROYS: a
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move_hero:

    ld a,de_x(ix) ;;  cargamos las posiciones y las velocidades
    add e_vx(ix)
    ld de_x(ix),a

    ld a, de_y(ix) 
    add e_vy(ix)
    ld de_y(ix),a

    ld bc, #enemy_shot_constant
    add ix,bc
    ld a, e_tmp(ix)
    or a
    jr z, no_rest
        dec a
        ld e_tmp(ix),a

no_rest:
    ld bc, #-enemy_shot_constant
    add ix,bc
    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;entity clear
;;INPUT: IX -> puntero a entidad
;;DESTROYS: HL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ent_clear:
    call ren_clearEntity
    ret



get_KeyBoard:
    call cpct_scanKeyboard_asm
    ld hl,#Key_A
    call cpct_isKeyPressed_asm
    jr z, a_no_pulsada
    ld a,#1

    ld (m_num_coordenada),a
    ld a,#k_tank_velocity_x
    ld e_eye(ix),#4
    neg
    ld e_vx(ix),a
    ld e_vy(ix),#0
   
    push af
    ld a, (unavariable)
    or a
    ld hl, #_sprite_Hero_left
    call z,cambiar_sprite
    call nz,cambiar_spriteB
    ld hl, #_sprite_Hero_left2
    call z,cambiar_spriteB
    call nz,cambiar_sprite
    pop af

    jp key_pulsada

a_no_pulsada:    
    ld hl,#Key_D
    call cpct_isKeyPressed_asm
    jr z, d_no_pulsada
    ld a,#1
    ld (m_num_coordenada),a
    ld a,#k_tank_velocity_x
    ld e_eye(ix),#2
    ld e_vx(ix),a
    ld e_vy(ix),#0
    
    push af
    ld a, (unavariable)
    or a
    ld hl, #_sprite_Hero_right
    call z,cambiar_sprite
    call nz,cambiar_spriteB
    ld hl, #_sprite_Hero_right2
    call z,cambiar_spriteB
    call nz,cambiar_sprite
    pop af

    jr key_pulsada

d_no_pulsada:  
    ld hl,#Key_W
    call cpct_isKeyPressed_asm
    jr z, w_no_pulsada
    ld a,#0
    ld (m_num_coordenada),a
    ld a,#k_tank_velocity_y
    neg 
    ld e_eye(ix),#3
    ld e_vy(ix),a
    ld e_vx(ix),#0
 
    push af
    ld a, (unavariable)
    or a
    ld hl, #_sprite_Hero_up
    call z,cambiar_sprite
    call nz,cambiar_spriteB
    ld hl, #_sprite_Hero_up2
    call z,cambiar_spriteB
    call nz,cambiar_sprite
    pop af

    jr key_pulsada

w_no_pulsada:
    ld hl,#Key_S
    call cpct_isKeyPressed_asm
    jr z, key_no_pulsada
    ld a,#0
    ld (m_num_coordenada),a
    ld a,#k_tank_velocity_y
    ld e_eye(ix),#1
    ld e_vy(ix),a
    ld e_vx(ix),#0
 
    push af
    ld a, (unavariable)
    or a
    ld hl, #_sprite_Hero_down
    call z,cambiar_sprite
    call nz,cambiar_spriteB
    ld hl, #_sprite_Hero_down2
    call z,cambiar_spriteB
    call nz,cambiar_sprite
    pop af

    jr key_pulsada
key_no_pulsada:
    ld a,#0
key_pulsada:
    ret
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;entity moverkey
;;INPUT: ix
;;DESTROYS: A o l ,HL 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_moveKeyBoard:
        ld a, e_tmp(ix)
        or a
        jr z, es_cero
            dec a
            ld e_tmp(ix),a
    es_cero:

    call get_KeyBoard
    or a
    jr z,no_mover_tank
    call comprobar_colision
    or a
    jr nz,no_mover_tank
    call ent_mover_tank
no_mover_tank:

ret

;; entry ix -> puntero 
;; a-> la velocidad que se mueve
;; se ha modificado anteriormente el ojo donde se ha movido
comprobar_colision:
    ld c,a
    ld a,(m_back_buffer)
    ld h,a
    ld l,#0
    ex de,hl
    ;ld a,(m_num_coordenada)
    call get_velocitat
    or a
    jr z,comprobar_colision_y
    ld a, de_x(ix)
    add c
    ld b,de_y(ix)
    ld c,a

    ld a,#7
    ld h,a
    ld l,#0x00
next_coordenada_x:
    push de
    push af
    push hl
    push bc
    add hl,bc
    ld b,h
    ld c,l
    call cpct_getScreenPtr_asm
    call ent_colision_x
    or a
    jr nz,colision_eje
    pop bc
    pop hl 
    pop af
    pop de
    dec h
    dec a
    jr nz,next_coordenada_x
    ld a,#0x00
    jr end_comprobar_colision
comprobar_colision_y:
    ld a,c
    or a
    jp m,eje_y_up
    ld a,#7
    jr modificado_eje_y_down
eje_y_up:
    ld a,#0
modificado_eje_y_down:
    call ent_colision_y
    or a
    jr z,end_comprobar_colision
    ld a,#0x01
    jr end_comprobar_colision
colision_eje:
    pop bc
    pop hl 
    pop af
    pop de
    ld a,#0x01
end_comprobar_colision:    
ret



ent_mover_tank:
    ld a,(m_num_coordenada)
    or a
    jr z,ent_mover_tank_y
    ld a,de_x(ix)
    add e_vx(ix)
    ld de_x(ix),a
    jr terminar_mover
ent_mover_tank_y:
    ld a,de_y(ix)
    add e_vy(ix)
    ld de_y(ix),a
terminar_mover:
ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FUNCIÓN PARA COMPROBAR SI HAY BLOQUE EN EL EJE X
;; ENTRY:
;;          c  -> la posición del heroe
;;          ix -> puntero a la direccion del heroe
;; DESTROY:
;;          a
;; RETURN:
;;          a = 1 -> collision
;;          a = 0 -> no collision         
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_bloque_eje_x:

    ld a,c                                  ;; cargamos en a la posicion del e_x, a = c
    sub #0x04                               ;; restamos 4 para ver si esta en el borde del margen del mapa a = a - 4
    jr z,no_collision1                      ;; si a = 0 no hay colision
    jp p,siguiente_x                        ;; si el numero es positivo pasamos a comprobar el lado derecho a > 0 ya que no colision por la izquierda
    jr collision_x                          ;; a < 0 , colisiona saltamos  al return

siguiente_x:
    ld a,c                                  ;; cargamos en a la posicion del e_x, a = c
    add  #0x04                        ;; le sumamos la anchura a = a + anchura(e_w)
    sub #80-4                               ;; le restamos lo maximo que se pueda mover a la derecha
    jr z,no_collision1                      ;; si es  a = 0 no colisiona significa que estamo en el borde
    jp m,no_collision1                      ;; si es negativo a < 0 significa que no hemos llegamos al maximo de movimiento y por tanto no hay colision

collision_x:                                ;; etiqueta de que si colisiona el return es a = 1
    ld a,#0x01                              
    ret

no_collision1:                              ;; etiqueta de no colision , por tanto a = 0
    ld a,#0x00
    ret
    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FUNCIÓN PARA COMPROBAR SI HAY BLOQUE EN EL EJE Y
;; ENTRY:
;;          c  -> la posición del heroe
;;          ix -> puntero a la direccion del heroe
;; DESTROY:
;;          a
;; RETURN:
;;          a = 1 -> collision
;;          a = 0 -> no collision         
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_bloque_eje_y:

    ld l,c                                  ;; cargamos en l = c
    push bc                                 ;; guardamos en la pila bc, solo nos interesa  c , ya que contiene la direccion del heroe
    ld h,#0x00                              ;; restauramos h por si tenia datos h = 00
    ld bc,#0xFFF8                           ;; cargamos en BC el valor en negativo bc = -8
    add hl,bc                               ;; hacemos la operación hl = hl + bc , nota = bc es negativo  para probar si ha llegado arriba del todo 
    ld a,h                                  ;; cargamos en a = h                                  
    and a                                   ;; en a = a && a, lo hacemos por que si la operacion de hl da un numero negativo al hacer un and comprobamos el flag z o negativo 
    jr z,siguiente_y                        ;; si es a = 00 pasamos a mirar abajo
    jp p,siguiente_y 
    pop bc                       ;; si es a a >= 0 significa que no hemos llegamos al borde 
    jr collision_y                          ;; return para 

siguiente_y:
    pop bc                                  ;; sacamos el  valor de la pila para obtener c
    ld a,c                                  ;; cargamos en a = c
    add #0x08                            ;; sumamos la altura a = a + altura
    ld l,a                                  ;; cargamos en l  la suma de a l = a
    ld h,#0x00                              ;; restauramos el valor de hl = 00
    ld bc,#0xFF3F                           ;; cargamos en bc el valor = - 192 , en negativo
    add hl,bc                               ;; hacemos la operación de hl = hl + bc
    jr c,collision_y                        ;; si se activa el flag de carry significa que hay colision
    ld a,h                                  ;; cargamos  a = h
    and a                                   ;; en a = a && a, lo hacemos por que si la operacion de hl da un numero negativo al hacer un and comprobamos el flag z o negativo 
    jr nz,no_collision2                     ;; si  a != 0 significa que no hay colision      

collision_y:                                ;; return a = 1
    ld a,#0x01                                   ;; devolvemos el valor de la pila porque si se ha cumplido el primer if , sino daria errores
    ret
no_collision2:                              ;; return a = 0
    ld a,#0x00              
ret

;;Entrada IX -> Entidad
ex_sprite_spriteB:
    ld l, e_spriteB_l(ix)
    ld h, e_spriteB_h(ix)
    ld e, de_sprite_l(ix)
    ld d, de_sprite_h(ix)
    ld e_spriteB_l(ix), e
    ld e_spriteB_h(ix), d
    ld de_sprite_l(ix), l
    ld de_sprite_h(ix), h
ret

explosion: .db 0x00         ;X         0
           .db 0x00         ;Y         1
           .dw  _sprite_exp1;Sprite    2 3
           .db 0x00         ;Dibujar   4
           .db 0x00         ;Contador  5
           .db 0x00         ;Nº sprite 6
           habia_explosion:
           .db 0x00         ;0->No habia explosion antes 7
                            ;1->Habia explosion antes   
           .db 0x00
           .db 0x00
           .db 0x00
           .db 0x00
           .db 0x00
           .db 0x00         ;x_aa 13
           .db 0x00         ;y_aa 14

duracion_explosion = 4
init_explosion:
    ;push ix
    ;ld ix,#explosion
    ;ld a,7(ix)
    ;or a
    ;call nz,ren_clear_backbuffer
    ;call nz,ren_clear_frontbuffer
    ;pop ix

    ld a,(habia_explosion)
    or a
    jr nz,salir2

    ld iy, #explosion
    ld a, de_x(ix)
    ld 0(iy), a
    ld e_xaa(iy), a
    ld a, de_y(ix)
    ld 1(iy), a
    ld e_yaa(iy), a
    ld hl, #_sprite_exp1
    ld 3(iy),h
    ld 2(iy),l
    ld 4(iy), #1
    ld 5(iy), #duracion_explosion
    ld 6(iy), #0
    ld 7(iy), #1
salir2:
ret

load_explosion:
    ld ix, #explosion
    ld a, 4(ix)
    or a
    jr z,salir
    call ent_draw
    ld a, 5(ix)
    or a
    jr nz,actualizar_contador
    call change_sprites_explosion
    ld 5(ix), #duracion_explosion
    jr salir
actualizar_contador:
    dec a
    ld 5(ix), a
salir:
ret

change_sprites_explosion:
    ld a,6(ix)
    or a
    jr z, exp1
    dec a
    jr z, exp2
    dec a
    jr z, exp3
    dec a
    jr z, exp4
exp1:
    ld hl, #_sprite_exp2
    ld 3(ix),h
    ld 2(ix),l
    ld 6(ix), #1
    jr salir_ch
exp2:
    ld hl, #_sprite_exp3
    ld 3(ix),h
    ld 2(ix),l
    ld 6(ix), #2
    jr salir_ch
exp3:
    ld hl, #_sprite_exp4
    ld 3(ix),h
    ld 2(ix),l
    ld 6(ix), #3
    jr salir_ch
exp4:
    call ren_clear_backbuffer
    call ren_clear_frontbuffer
    ld 4(ix), #0
    ld 7(ix), #0
salir_ch:
ret

reset_explosion:
    ld iy, #explosion
    ld 0(iy), #0
    ld 1(iy), #0
    ld e_xaa(iy), #0
    ld e_yaa(iy), #0
    ld hl, #_sprite_exp1
    ld 3(iy),h
    ld 2(iy),l
    ld 4(iy), #0
    ld 5(iy), #0
    ld 6(iy), #0
    ld 7(iy), #0
ret

load_final_enemies:
    ld a,#3
    ld (difficulty), a
ret

load_strong_enemies:
    ld a,#2
    ld (difficulty), a

    ld hl, #_sprite_Enemy22_up
    ld (SpriteEnemyUp), hl
    ld (Sprite1EnemyUp), hl
    ld (Sprite2EnemyUp), hl
    ld hl, #_sprite_Enemy2_up2
    ld (SpriteEnemyUp2), hl
    ld (Sprite1EnemyUp2), hl
    ld (Sprite2EnemyUp2), hl

    ld hl, #_sprite_Enemy22_right
    ld (SpriteEnemyRight), hl
    ld (Sprite1EnemyRight), hl
    ld (Sprite2EnemyRight), hl
    ld hl, #_sprite_Enemy2_right2
    ld (SpriteEnemyRight2), hl
    ld (Sprite1EnemyRight2), hl
    ld (Sprite2EnemyRight2), hl

    ld hl, #_sprite_Enemy22_left
    ld (SpriteEnemyLeft), hl
    ld (Sprite1EnemyLeft), hl
    ld (Sprite2EnemyLeft), hl
    ld hl, #_sprite_Enemy2_left2
    ld (SpriteEnemyLeft2), hl
    ld (Sprite1EnemyLeft2), hl
    ld (Sprite2EnemyLeft2), hl

    ld hl, #_sprite_Enemy22_down
    ld (SpriteEnemyDown), hl
    ld (Sprite1EnemyDown), hl
    ld (Sprite2EnemyDown), hl
    ld hl, #_sprite_Enemy2_down2
    ld (SpriteEnemyDown2), hl
    ld (Sprite1EnemyDown2), hl
    ld (Sprite2EnemyDown2), hl

    ld hl, #_sprite_Enemy22_right
    ld ix, #enemy_data
    call cambiar_sprite
    ld ix, #enemy_aux
    call cambiar_sprite
    ld hl, #ent_move_2
    ld e_up_l(ix), l
    ld e_up_h(ix), h

    ld hl, #_sprite_Enemy2_right2
    ld ix, #enemy_aux
    call cambiar_spriteB
    ld ix, #enemy_data
    call cambiar_spriteB
    ld hl, #ent_move_2
    ld e_up_l(ix), l
    ld e_up_h(ix), h
ret

load_weak_enemies:
    ld a, #1
    ld (difficulty), a

    ld hl, #_sprite_Enemy_up
    ld (SpriteEnemyUp), hl
    ld (Sprite1EnemyUp), hl
    ld (Sprite2EnemyUp), hl
    ld hl, #_sprite_Enemy_up2
    ld (SpriteEnemyUp2), hl
    ld (Sprite1EnemyUp2), hl
    ld (Sprite2EnemyUp2), hl

    ld hl, #_sprite_Enemy_right
    ld (SpriteEnemyRight), hl
    ld (Sprite1EnemyRight), hl
    ld (Sprite2EnemyRight), hl
    ld hl, #_sprite_Enemy_right2
    ld (SpriteEnemyRight2), hl
    ld (Sprite1EnemyRight2), hl
    ld (Sprite2EnemyRight2), hl

    ld hl, #_sprite_Enemy_left
    ld (SpriteEnemyLeft), hl
    ld (Sprite1EnemyLeft), hl
    ld (Sprite2EnemyLeft), hl
    ld hl, #_sprite_Enemy_left2
    ld (SpriteEnemyLeft2), hl
    ld (Sprite1EnemyLeft2), hl
    ld (Sprite2EnemyLeft2), hl

    ld hl, #_sprite_Enemy_down
    ld (SpriteEnemyDown), hl
    ld (Sprite1EnemyDown), hl
    ld (Sprite2EnemyDown), hl
    ld hl, #_sprite_Enemy_down2
    ld (SpriteEnemyDown2), hl
    ld (Sprite1EnemyDown2), hl
    ld (Sprite2EnemyDown2), hl

    ld hl, #_sprite_Enemy_right
    ld ix, #enemy_data
    call cambiar_sprite
    ld ix, #enemy_aux
    call cambiar_sprite
    ld hl, #ent_move
    ld e_up_l(ix), l
    ld e_up_h(ix), h

    ld hl, #_sprite_Enemy_right2
    ld ix, #enemy_aux
    call cambiar_spriteB
    ld ix, #enemy_data
    call cambiar_spriteB
    ld hl, #ent_move
    ld e_up_l(ix), l
    ld e_up_h(ix), h
ret

load_noob_enemies:
    ld a, #0
    ld (difficulty), a

    ld hl, #_sprite_Enemy3_up
    ld (SpriteEnemyUp), hl
    ld (Sprite1EnemyUp), hl
    ld (Sprite2EnemyUp), hl
    ld hl, #_sprite_Enemy3_up2
    ld (SpriteEnemyUp2), hl
    ld (Sprite1EnemyUp2), hl
    ld (Sprite2EnemyUp2), hl

    ld hl, #_sprite_Enemy3_right
    ld (SpriteEnemyRight), hl
    ld (Sprite1EnemyRight), hl
    ld (Sprite2EnemyRight), hl
    ld hl, #_sprite_Enemy3_right2
    ld (SpriteEnemyRight2), hl
    ld (Sprite1EnemyRight2), hl
    ld (Sprite2EnemyRight2), hl

    ld hl, #_sprite_Enemy3_left
    ld (SpriteEnemyLeft), hl
    ld (Sprite1EnemyLeft), hl
    ld (Sprite2EnemyLeft), hl
    ld hl, #_sprite_Enemy3_left2
    ld (SpriteEnemyLeft2), hl
    ld (Sprite1EnemyLeft2), hl
    ld (Sprite2EnemyLeft2), hl

    ld hl, #_sprite_Enemy3_down
    ld (SpriteEnemyDown), hl
    ld (Sprite1EnemyDown), hl
    ld (Sprite2EnemyDown), hl
    ld hl, #_sprite_Enemy3_down2
    ld (SpriteEnemyDown2), hl
    ld (Sprite1EnemyDown2), hl
    ld (Sprite2EnemyDown2), hl

    ld hl, #_sprite_Enemy3_right
    ld ix, #enemy_data
    call cambiar_sprite
    ld ix, #enemy_aux
    call cambiar_sprite
    ld hl, #ent_move_3
    ld e_up_l(ix), l
    ld e_up_h(ix), h

    ld hl, #_sprite_Enemy3_right2
    ld ix, #enemy_aux
    call cambiar_spriteB
    ld ix, #enemy_data
    call cambiar_spriteB
    ld hl, #ent_move_3
    ld e_up_l(ix), l
    ld e_up_h(ix), h
ret