;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Tank Ardad. A tank videogame.
;;  Copyright (C) 2018 Adrian Bardisa Serrano, Ariel Palma Arriaga, David Ruiz Falco
;;  abs90@alu.ua.es drf7@alu.ua.es acpa2@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "map.h.s"
.include "main.h.s"
.include "entity.h.s"
.include "menu.h.s"
.globl m_back_buffer
.globl m_front_buffer

m_next_level:  .dw m_level_array
k_max_level = 13
m_current_level: .db 0x00
m_level_array: .dw _level1 
               .dw _level2
               .dw _level3
               .dw _level4
               .dw _level1 
               .dw _level2
               .dw _level3
               .dw _level4
               .dw _level1 
               .dw _level2
               .dw _level3
               .dw _level4
               .dw _level5
difficulty: .db 0x00
               ;.dw _victory

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dibuja el mapa assets/map1.tmx
;; ENTRADA: BC -> puntero al mapa a dibujar
;; REGISTROS DESTRUIDOS: A, DE, BC, HL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

draw_map_back:
      ld hl, #_g_tileset ;;Pointer to the tiles
      call cpct_etm_setTileset2x4_asm
      push bc
      ld a,(m_back_buffer)
      ld h,a
      ld l,#0x00
      push hl
      ld bc, #0000 ;;Coordinates x,y where it starts drawing
      ld d, #50 ;;Map height in tiles
      ld e, #40 ;;Map width in tiles
      ld a, #40 ;;Map witdh
      call cpct_etm_drawTileBox2x4_asm
ret

draw_map_front:
      ld hl, #_g_tileset ;;Pointer to the tiles
      call cpct_etm_setTileset2x4_asm
      push bc
      ld a,(m_front_buffer)
      ld h,a
      ld l,#0x00
      push hl
      ld bc, #0000 ;;Coordinates x,y where it starts drawing
      ld d, #50 ;;Map height in tiles
      ld e, #40 ;;Map width in tiles
      ld a, #40 ;;Map witdh
      call cpct_etm_drawTileBox2x4_asm
ret


draw_map_menu:
      ld hl, #_g_tileset ;;Pointer to the tiles
      call cpct_etm_setTileset2x4_asm
      push bc
      ld a,(m_front_buffer)
      ld h,a
      ld l,#0x00
      push hl
      ld bc, #0000 ;;Coordinates x,y where it starts drawing
      ld d, #50 ;;Map height in tiles
      ld e, #40 ;;Map width in tiles
      ld a, #40 ;;Map witdh
      call cpct_etm_drawTileBox2x4_asm
ret

reboot_game:
      ld a,#0
      ld (m_num_ent), a
      ld hl,#entity_vector
      ld (m_next_entity),hl
      ld de, #hero_data
      ld hl, #hero_data_default
      ld bc, #k_entity_size
      ldir ; asume que HL esta apuntando a un sitio en memoria y DE en otro,
         ; y BC contiene un tamaño va leyendo de HL y copiando en DE y aumentando 
         ; hasta que BC llega a 0 
      ld de, #hero_shot
      ld hl, #hero_shot_default
      ld bc, #k_entity_size
      ldir
      call restore_health
      call reset_explosion
ret

load_next_level:
      ld a, (m_current_level)
      add #1
      ld b, #k_max_level
      cp b
      jr z,no_more_levels
      ld (m_current_level), a

      ld b, #4
      cp b
      call z,load_weak_enemies
      ld b, #8
      cp b
      call z,load_strong_enemies
      ld b, #12
      cp b
      call z,load_final_enemies
no_load_supertanks:
      ld hl, (m_next_level)
      ld bc, #2
      add hl, bc
      ld (m_next_level), hl;
      ld ix, (m_next_level)
      ld b, 1(ix)
      ld c, 0(ix)
      call draw_map_back
      ld ix, (m_next_level)
      ld b, 1(ix)
      ld c, 0(ix)
      call draw_map_front
      call reboot_game
      jr end
no_more_levels:
      ld hl, #m_level_array
      ld (m_next_level), hl
      ld a, #0
      ld (m_current_level), a
      ld (difficulty), a
      ld bc, #_victory
      call draw_map_back
      ld bc, #_victory
      call draw_map_front
      call reboot_game
      call load_noob_enemies
      ld a, #255
espera2:
      halt
      halt
      halt
      halt
      dec a
      jr nz, espera2
      pop ix
      jp reiniciar
end:
ret

load_game_over:
      ld bc, #_gameOver
      call draw_map_back
      ld bc, #_gameOver
      call draw_map_front
      ld a, #255
espera:
      halt
      dec a
      jr nz, espera
      call reboot_game
      call load_noob_enemies
      ld hl, #m_level_array
      ld (m_next_level), hl
      ld a, #0
      ld (m_current_level), a
      ld (difficulty), a
ret