;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Tank Ardad. A tank videogame.
;;  Copyright (C) 2018 Adrian Bardisa Serrano, Ariel Palma Arriaga, David Ruiz Falco
;;  abs90@alu.ua.es drf7@alu.ua.es acpa2@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "menu.h.s"
.include "map.h.s"
.include "main.h.s"
.include "cpctelera.h.s"
.include "render.h.s"

DefineDrawableEntity hearth_one   76, 24, _sprite_hearth
DefineDrawableEntity hearth_two   76, 36, _sprite_hearth
DefineDrawableEntity hearth_three 76, 48, _sprite_hearth

load_hearths:
  ld ix, #hearth_one
  call ren_drawEntity
  call ren_drawEntity_front
  ld ix, #hearth_one
  call ren_drawEntity
  call ren_drawEntity_front
  ld ix, #hearth_two
  call ren_drawEntity
  call ren_drawEntity_front
  ld ix, #hearth_three
  call ren_drawEntity
  call ren_drawEntity_front
ret

restore_health:
  ld ix, #hearth_one
  ld hl, #_sprite_hearth
  ld de_sprite_h(ix), h
  ld de_sprite_l(ix), l
  ld ix, #hearth_two
  ld de_sprite_h(ix), h
  ld de_sprite_l(ix), l
  ld ix, #hearth_three
  ld de_sprite_h(ix), h
  ld de_sprite_l(ix), l
ret

load_menu:
  call cpct_akp_stop_asm
	ld bc, #_menu
	call draw_map_menu
  call ren_draw_menu
  call ren_clear_menu
loop:
  call cpct_scanKeyboard_asm
  ld hl, #Key_H
  call cpct_isKeyPressed_asm
  jr z, h_nopulsada
  jr end_loop
  h_nopulsada:
  ld hl, #Key_F
  call cpct_isKeyPressed_asm
  jr z, f_nopulsada
  ld bc, #_instructions
  call draw_map_menu
  call exit_instructions
  ld bc, #_menu
  call draw_map_menu
  call ren_draw_menu
  call ren_clear_menu
  f_nopulsada:

  jr loop
  end_loop:
ret

exit_instructions:
esc_nopulsada:
	call cpct_scanKeyboard_asm
	ld hl, #Key_Esc
  call cpct_isKeyPressed_asm
  jr z, esc_nopulsada
ret