;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Tank Ardad. A tank videogame.
;;  Copyright (C) 2018 Adrian Bardisa Serrano, Ariel Palma Arriaga, David Ruiz Falco
;;  abs90@alu.ua.es drf7@alu.ua.es acpa2@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "entity.h.s"
.include "main.h.s"
.include "colisions.h.s"
.include "movement.h.s"

k_follow_x = 40
k_follow_y = 60

;;modulo 4
;;entry: A -> valor
modulo4:
    ld b, #4
    cp b ; A - B
    jr c, menor_que_cuatro
        sub #4
        jp modulo4
menor_que_cuatro:
    ret


modulo9:
    ld b, #9
    cp b ; A - B
    jr c, menor_que_cuatr
        sub #9
        jp modulo9
menor_que_cuatr:
    ret 
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Patron de movimiento
;; INPUT: IX -> puntero a entidad,
;; REGISTROS DESTRUIDOS: A, B,
;; SALIDA: B -> 1 si hay tanques, 0 si no hay
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
change_direction:
    
;HACERLO CON MODULO 4
    call cpct_getRandom_mxor_u8_asm ; te devuelve en l el random
    ld a, l
    call modulo4

    or a
    jr z, der
    dec a
    jr z, izq
    dec a
    jr z, aba
    dec a
    jr z, arri

    ret

der:
    ld e_vx(ix),#1
    ld e_vy(ix),#0
    Sprite1EnemyRight = . + 1
    ld hl, #_sprite_Enemy3_right
    call cambiar_sprite
    Sprite1EnemyRight2 = . + 1
    ld hl, #_sprite_Enemy3_right2
    call cambiar_spriteB
    ret
aba:
    ld e_vx(ix),#0
    ld e_vy(ix),#-1
    Sprite1EnemyUp = . + 1
    ld hl, #_sprite_Enemy3_up
    call cambiar_sprite
    Sprite1EnemyUp2 = . + 1
    ld hl, #_sprite_Enemy3_up2
    call cambiar_spriteB
    ret
izq:
    ld e_vx(ix),#-1
    ld e_vy(ix),#0
    Sprite1EnemyLeft = . + 1    
    ld hl, #_sprite_Enemy3_left
    call cambiar_sprite
    Sprite1EnemyLeft2 = . + 1
    ld hl, #_sprite_Enemy3_left2
    call cambiar_spriteB
    ret
arri:
    ld e_vx(ix),#0
    ld e_vy(ix),#1
    Sprite1EnemyDown = . + 1
    ld hl, #_sprite_Enemy3_down
    call cambiar_sprite
    Sprite1EnemyDown2 = . + 1
    ld hl, #_sprite_Enemy3_down2
    call cambiar_spriteB
    ret 
 
ent_es_par:

buclee:
    or a
    jr z, es_par  
    dec a
    jr z, es_impar
    dec a

    jp buclee
es_par:
    ld a, #1
    ret
es_impar:
    ld a, #-1
    ret

look_back:
	ld a, e_vx(ix)
	jr z, cero_x
	add #1
	jr z, estaba_izq
    Sprite2EnemyRight = . + 1
	ld hl, #_sprite_Enemy3_right
	call cambiar_sprite
    Sprite2EnemyRight2 = . + 1
    ld hl, #_sprite_Enemy3_right2
    call cambiar_spriteB
ret
estaba_izq:
    Sprite2EnemyLeft = . + 1
	ld hl, #_sprite_Enemy3_left
    call cambiar_sprite
    Sprite2EnemyLeft2 = . + 1
    ld hl, #_sprite_Enemy3_left2
    call cambiar_spriteB
ret
cero_x:
	ld a, e_vy(ix)
	add #1
	jr z, estaba_abajo
    Sprite2EnemyUp = . + 1
	ld hl, #_sprite_Enemy3_up
	call cambiar_sprite
    Sprite2EnemyUp2 = . + 1
    ld hl, #_sprite_Enemy3_up2
    call cambiar_spriteB
ret
estaba_abajo:
    Sprite2EnemyDown = . + 1
	ld hl, #_sprite_Enemy3_down
	call cambiar_sprite
    Sprite2EnemyDown2 = . + 1
    ld hl, #_sprite_Enemy3_down2
    call cambiar_spriteB
ret
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Patron de movimiento
;; INPUT: IX -> puntero a entidad,
;; REGISTROS DESTRUIDOS: A, B,
;; SALIDA: B -> 1 si hay tanques, 0 si no hay
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
look_sides:
	call cpct_getRandom_mxor_u8_asm
	ld a,l
	call modulo4
	or a
	jr z, quieto
	jp change_direction

quieto:
;Aqui podria poner un 50% para que mire atras
call look_back
	ld e_vx(ix),#0
	ld e_vy(ix),#0
ret
 
    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Patron de movimiento
;; INPUT: IX -> puntero a entidad,
;; REGISTROS DESTRUIDOS: A, B,
;; SALIDA: B -> 1 si hay tanques, 0 si no hay
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pat_movement:

    ld a, e_vx(ix)
    ld b, e_vy(ix)
    add b
    call comprobar_colision

    jr nz, no_moversee
    	ld a, e_tmp(ix)
    	or a
	    jr z, tiempo_cero

    	dec a
    	ld e_tmp(ix),a
    	jp ent_move_hero
tiempo_cero:
		;call cpct_getRandom_mxor_u8_asm
		;ld a,l
		;call modulo4
		;add #1
		ld e_tmp(ix),#0x20   
		jp look_sides
no_moversee:
    jp change_direction
    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Devuelve un 1 si hay tanques, sino un 0
;; REGISTROS DESTRUIDOS: AF, AF', IX, IY, B
;; SALIDA: B -> 1 si hay tanques, 0 si no hay
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
distancia_x_2:
    ld a, de_x(ix)
    ;ld c, de_y(ix)
    ld iy, #hero_data

    ld b, de_x(iy)
    ;ld d, de_y(iy)

    cp b ; b - A
    jr c, a_menor_x_2
        ex AF, AF'
        ld a, b
        ex AF, AF'
        cp b
        jr c, no_moverse_x_2
            ld a,#1
            ret
a_menor_x_2:
        or a
        ld a,de_x(ix)
        add #80
        cp b
        jr c, no_moverse_x_2 ; esta mas lejos que 30
            ld a,#1
            ret

no_moverse_x_2:
    ld a,#0
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Devuelve un 1 si hay tanques, sino un 0
;; REGISTROS DESTRUIDOS: AF, AF', IX, IY, B
;; SALIDA: B -> 1 si hay tanques, 0 si no hay
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
distancia_y_2:
    ld a, de_y(ix)
    ;ld c, de_y(ix)
    ld iy, #hero_data

    ld b, de_y(iy)
    ;ld d, de_y(iy)

    cp b ; b - A
    jr c, a_menor_2
        ex AF, AF'
        ld a, b
        ex AF, AF'
        cp b
        jr c, no_moverse_y_2
            ld a,#1
            ret
a_menor_2:
        or a
        ld a, de_y(ix)
        add #90
        cp b
        jr c, no_moverse_y_2 ; esta mas lejos que 30
            ld a,#1
            ret

no_moverse_y_2:
    ld a,#0
    ret  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Devuelve un 1 si hay tanques, sino un 0
;; REGISTROS DESTRUIDOS: AF, AF', IX, IY, B
;; SALIDA: B -> 1 si hay tanques, 0 si no hay
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
distancia_x:
    ld a, de_x(ix)
    ;ld c, de_y(ix)
    ld iy, #hero_data

    ld b, de_x(iy)
    ;ld d, de_y(iy)

    cp b ; b - A
    jr c, a_menor_x
        ex AF, AF'
        ld a, b
        ex AF, AF'
        cp b
        jr c, no_moverse_x
            ld a,#1
            ret
a_menor_x:
        or a
        ld a,de_x(ix)
        add #k_follow_x
        cp b
        jr c, no_moverse_x ; esta mas lejos que 30
            ld a,#1
            ret

no_moverse_x:
    ld a,#0
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Devuelve un 1 si hay tanques, sino un 0
;; REGISTROS DESTRUIDOS: AF, AF', IX, IY, B
;; SALIDA: B -> 1 si hay tanques, 0 si no hay
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
distancia_y:
    ld a, de_y(ix)
    ;ld c, de_y(ix)
    ld iy, #hero_data

    ld b, de_y(iy)
    ;ld d, de_y(iy)

    cp b ; b - A
    jr c, a_menor
        ex AF, AF'
        ld a, b
        ex AF, AF'
        cp b
        jr c, no_moverse_y
            ld a,#1
            ret
a_menor:
        or a
        ld a, de_y(ix)
        add #k_follow_y
        cp b
        jr c, no_moverse_y ; esta mas lejos que 30
            ld a,#1
            ret

no_moverse_y:
    ld a,#0
    ret    


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Devuelve un 1 si hay tanques, sino un 0
;; REGISTROS DESTRUIDOS: A, B,
;; SALIDA: B -> 1 si hay tanques, 0 si no hay
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
no_hay_tanques:
    ld a, (m_num_ent)
    jr z, hay_cero
        ld b, #1
        ret
hay_cero:
    ld b,#0
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Viene a por ti eje x
;; INPUT: IX -> puntero a entidad
;; REGISTROS DESTRUIDOS: A, BC, IX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move_enemy_x:

    ld b, de_x(ix)
    ld e_vy(ix),#0
    ld iy, #hero_data
    ld a, de_x(iy)

    cp b ; A - B
    jp c, menor_que_b_x
        ld e_vx(ix),#1
        ret

menor_que_b_x:
    ld e_vx(ix),#-1
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Viene a por ti eje y
;; INPUT: IX -> puntero a entidad
;; REGISTROS DESTRUIDOS: A, BC, IX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move_enemy_y:
	ld e_vx(ix),#0
    ld b, de_y(ix)

    ld iy, #hero_data
    ld a, de_y(iy)

    cp b ; A - B
    jp c, menor_que_b
        ld e_vy(ix),#1
        ret

menor_que_b:
    ld e_vy(ix),#-1
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Si tu x es mayor que la del enemigo, viene hacia la tuya
;; INPUT: IX -> puntero a entidad
;; REGISTROS DESTRUIDOS: A, BC, IX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move_enemy:

    call ent_move_enemy_x
    call ent_move_enemy_y
ret
